﻿namespace Votations.NSurvey.SQLServerDAL
{
    using Microsoft.ApplicationBlocks.Data;
    using System;
    using System.Data;
    using System.Data.SqlClient;
    using System.Runtime.InteropServices;
    using Votations.NSurvey.Data;
    using Votations.NSurvey.IDAL;

    /// <summary>
    /// SQL Server DAL implementation.
    /// </summary>
    public class SurveyLayout : ISurveyLayout
    {
        #region ISurveyLayout Members
         
        public SurveyLayoutData SurveyLayoutGet(int surveyId,string languageCode=null)
        {
            SurveyLayoutData sld = new SurveyLayoutData();
            SqlHelper.FillDataset(SqlHelper.DbConnectionString, CommandType.StoredProcedure, "vts_spSurveylayoutGet", sld,
                new string[] { "SurveyLayout" },
                new SqlParameter[] { new SqlParameter("@SurveyId", surveyId), new SqlParameter("@LanguageCode", languageCode) });

            return sld;
        }

        public void SurveyLayoutUpdate(SurveyLayoutData sld, string languageCode = null)
        {
            SqlConnection connection = new SqlConnection(SqlHelper.DbConnectionString);
            SqlCommand command = new SqlCommand("vts_spSurveyLayoutUpdate", connection);
            command.CommandType = CommandType.StoredProcedure;
            command.Parameters.Add(new SqlParameter("@SurveyID",sld.SurveyLayout[0].SurveyId));
            command.Parameters.Add(new SqlParameter("@SurveyHeaderText", sld.SurveyLayout[0].SurveyHeaderText));
            command.Parameters.Add(new SqlParameter("@SurveyFooterText", sld.SurveyLayout[0].SurveyFooterText));
            command.Parameters.Add(new SqlParameter("@SurveyCss", sld.SurveyLayout[0].SurveyCss));
            command.Parameters.Add(new SqlParameter("@LanguageCode", languageCode));
            
         //   insertCommand.Parameters.Add(new SqlParameter("@SurveyId", SqlDbType.Int, 0xff, "RoleName"));
          
            SqlHelper.UpdateDataset(command, new SqlCommand(), new SqlCommand(), sld, "SurveyLayout", true);
         //   SqlHelper.ExecuteNonQuery(SqlHelper.DbConnectionString, CommandType.StoredProcedure, "vts_spRoleSecurityRightAddNew", commandParameters);
        }

        #endregion
    }
}