﻿namespace Votations.NSurvey.SQLServerDAL
{
    using System;
    using Votations.NSurvey.Data;
    using Votations.NSurvey.IDAL;
    using Microsoft.ApplicationBlocks.Data;
    using System.Data;
    using System.Data.SqlClient;
    using System.Linq;
    using Microsoft.SqlServer.Server;
    using System.Collections.Generic;

    public class SurveyToken : ISurveyToken
    {

        #region ISurveyToken Members

        public SurveyTokenData GetAllSurveyTokens(int surveyID)
        {
            SurveyTokenData surveyTokenData = new SurveyTokenData();

            SqlHelper.FillDataset(SqlHelper.DbConnectionString, CommandType.StoredProcedure, "vts_spTokenGetForSurvey", surveyTokenData,
                new string[] { "surveyToken" }, new SqlParameter[] { new SqlParameter("@SurveyId", surveyID) });

            return surveyTokenData;
        }

        public bool ValidateToken(int surveyID, string token)
        {
            object obj2 = SqlHelper.ExecuteScalar(SqlHelper.DbConnectionString, CommandType.StoredProcedure, "vts_spSurveyTokenValidate",
                new SqlParameter[] { new SqlParameter("@SurveyId", surveyID), new SqlParameter("@token", token) });
            if (obj2 == null)
            {
                return false;
            }
            return int.Parse(obj2.ToString()) ==0?false:true;
        }


        public void UpdateToken(int surveyID, string token,int voterId)
        {
            object obj2 = SqlHelper.ExecuteScalar(SqlHelper.DbConnectionString, CommandType.StoredProcedure, "vts_spSurveyTokenUpdate",
                new SqlParameter[] { new SqlParameter("@SurveyId", surveyID), new SqlParameter("@token", token) ,new SqlParameter("@voterId", voterId) });
        }
        public void DeleteSurveyTokensByIdMultiple(IEnumerable<int> ids)
        {
            SqlMetaData[] tab = { new SqlMetaData("value", SqlDbType.Int) };
            List<SqlDataRecord> idList =
            ids.Select(x => { var y = new SqlDataRecord(tab); y.SetInt32(0, x); return y; }).ToList<SqlDataRecord>();

            SqlParameter p = new SqlParameter("@tblTokenIdList", SqlDbType.Structured);
            p.Direction = ParameterDirection.Input;
            p.TypeName = "dbo.IntTableType";
            p.Value = idList;

            SqlCommand cmd = new SqlCommand();
            using (SqlConnection conn = new SqlConnection(SqlHelper.DbConnectionString))
            {
                conn.Open();
                cmd.Connection = conn;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.CommandText = "vts_spSurveyTokenDeleteMultiple";
                cmd.Parameters.Add(p);
                cmd.ExecuteNonQuery();
            }
        }

        public void AddSurveyTokensMultiple(int surveyId, DateTime creationDate, IEnumerable<string> tokens)
        {
            SqlMetaData[] tab = { new SqlMetaData("value", SqlDbType.VarChar, 40) };
            List<SqlDataRecord> tokenList =
            tokens.Select(x => { var y = new SqlDataRecord(tab); y.SetSqlString(0, x); return y; }).ToList<SqlDataRecord>();

            SqlParameter p = new SqlParameter("@tblTokenList", SqlDbType.Structured);
            p.Direction = ParameterDirection.Input;
            p.TypeName = "dbo.VarcharTableType";
            p.Value = tokenList;

            SqlCommand cmd = new SqlCommand();
            using (SqlConnection conn = new SqlConnection(SqlHelper.DbConnectionString))
            {
                conn.Open();
                cmd.Connection = conn;
                cmd.CommandType = CommandType.StoredProcedure;
                cmd.CommandText = "vts_spSurveyTokenAddMultiple";
                cmd.Parameters.Add(p);
                cmd.Parameters.Add(new SqlParameter("@SurveyID", surveyId));
                cmd.Parameters.Add(new SqlParameter("@CreationDate", creationDate));

                cmd.ExecuteNonQuery();
            }
            //   SqlHelper.ExecuteNonQuery(SqlHelper.DbConnectionString, "vts_spSurveyTokenAddMultiple", pars);

        }


        #endregion
    }
}
